{% macro _menu_secondary_item(item) %}
  {% set attributes = item.attributes|default({}) %}
  {% set link_attributes = item.link_attributes|default({}) %}
  <li {{ attributes|add_class("usa-nav__secondary-item") }}>
    {% set link_attributes = link_attributes|set_attribute("href", item.url) if item.url else link_attributes %}
    <a {{ link_attributes }}>{{ item.title }}</a>
  </li>
{% endmacro %}
{% macro _menu_primary(items, nav_id, use_megamenu) %}
  {% if items %}
    <ul class="usa-nav__primary usa-accordion">
      {% for item in items %}{{ _menu_primary_item(item, loop.index, nav_id, use_megamenu) }}{% endfor %}
    </ul>
  {% endif %}
{% endmacro %}
{% macro _menu_primary_item(item, loop_index, nav_id, use_megamenu) %}
  {% set section_id = nav_id ~ "-section-" ~ loop_index %}
  {% set attributes = item.attributes|default({})|add_class("usa-nav__primary-item") %}
  <li {{ attributes }}>
    {% set link_attributes = item.link_attributes|default({})|add_class("usa-nav__link") %}
    {% set link_attributes = link_attributes|add_class("usa-current") if item.in_active_trail else link_attributes %}
    {% if item.below and use_megamenu %}
      {% set link_attributes = link_attributes|add_class("usa-accordion__button")|set_attribute("type", "button") %}
      <button {{ link_attributes|set_attribute('aria-expanded', 'false') |set_attribute("aria-controls", section_id) }}>
        <span>{{ item.title }}</span>
      </button>
      {{ _submenu_mega(item.below, section_id) if use_megamenu else _submenu_simple(item.below, section_id) }}
    {% else %}
      {% set attributes = link_attributes|set_attribute("href", item.url) if item.url else attributes %}
      <a {{ attributes }}>
        <span>{{ item.title }}</span>
      </a>
    {% endif %}
  </li>
{% endmacro %}
{% macro _submenu_simple(items, section_id) %}
  <ul id="{{ section_id }}" class="usa-nav__submenu">
    {% for item in items %}{{ _submenu_link(item) }}{% endfor %}
  </ul>
{% endmacro %}
{% macro _submenu_mega(items, section_id) %}
  <div id="{{ section_id }}"
       class="usa-nav__submenu usa-megamenu"
       hidden="hidden">
    <div class="grid-row grid-gap-4">
      {% for submenu in items %}
        <div class="usa-col grid-col-auto">
          <ul class="usa-nav__submenu-list">
            {{ _submenu_link(submenu) }}
            {% if submenu.below %}
              <ul class="usa-nav__submenu-list">
                {% for submenu_links in submenu.below %}{{ _submenu_link(submenu_links) }}{% endfor %}
              </ul>
            {% endif %}
          </ul>
        </div>
      {% endfor %}
    </div>
  </div>
{% endmacro %}
{% macro _submenu_link(item) %}
  {% set attributes = item.attributes|default({})|add_class("usa-nav__submenu-item") %}
  {% set link_attributes = item.link_attributes|default({}) %}
  {% set link_attributes = link_attributes|set_attribute("href", item.url) if item.url else link_attributes %}
  <li {{ attributes }}>
    {% if link_attributes|has_attribute("href") %}
      <a {{ link_attributes }}>{{ item.title }}</a>
    {% else %}
      <strong {{ link_attributes }}>{{ item.title }}</strong>
    {% endif %}
  </li>
{% endmacro %}
{% set nav_id = "usa-nav-" ~ nav_id|default(random()) %}
<nav {{ attributes|add_class("usa-nav") |set_attribute("role", "navigation") }}>
  <div class="usa-nav__inner">
    <button type="button" class="usa-nav__close">
      <img src="{{ close_icon }}" alt="{{ "Close"|t }}" />
    </button>
    {% if secondary or search %}
      <div class="usa-nav__secondary">
        {% if secondary %}
          <ul class="usa-nav__secondary-links">
            {% for item in secondary %}{{ _menu_secondary_item(item) }}{% endfor %}
          </ul>
        {% endif %}
        {% if search %}
          <section aria-label="{{ "Search"|t }}">
            {{ search }}
          </section>
        {% endif %}
      </div>
    {% endif %}
    {{ _menu_primary(primary, nav_id, use_megamenu) }}
  </div>
</nav>
